/* esiste_somma.c */
#include <stdio.h>

void print_array(int a[], int n);

/* Realizzare la funzione esiste_somma() in base alla seguente
   specifica. La funzione accetta come parametri un array a[] di
   lunghezza n e un intero k. La funzione deve restituire 1 se e solo
   se esistono due elementi di a[], in posizioni diverse, la cui somma
   sia k.  Formalmente, la funzione deve restituire 1 se e solo se
   esistono due indici i, j con i != j tali che (a[i] + a[j] == k); se
   tali indici non esistono, la funzione restituisce 0.

   Si tenga presente che:
   - si avra' sempre n>0 (l'array a[] sara' sempre non vuoto);
   - l'array a[] non e' necessariamente ordinato;
   - l'array a[] puo' contenere valori duplicati.

   Ad esempio, se a[] = {19, -3, 2, 5, 2} e k = 4, la funzione deve
   restituire 1 perche' a[2] + a[4] == 4; si faccia riferimento
   ai test per ulteriori esempi. */
int esiste_somma(int a[], int n, int k)
{
    return -1;
}

/**
 ** Non dovrebbe essere necessario modificare le funzioni che seguono
 **/

/* Stampa il contenuto dell'array a[] di lunghezza n>=0 */
void print_array(int a[], int n)
{
    int i;
    printf("{");
    for (i=0; i<n; i++) {
        printf("%d", a[i]);
        if ( i<n-1 ) {
            printf(" ");
        }
    }
    printf("}");
}

/* Esegue i test */
void test(int a[], int n, int k, int expect)
{
    int r = esiste_somma(a, n, k);
    if ( r == expect ) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: a[]=");
        print_array(a, n);
        printf(", k=%d, risultato atteso=%d, risultato ottenuto=%d\n", k, expect, r);
    }
}

int main( void )
{
    int a1[] = {19, -3, 2, 5, 2}, k1 = 4, e1 = 1;
    int a2[] = {2}, k2 = 2, e2 = 0;
    int a3[] = {-3, 2}, k3 = -1, e3 = 1;
    int a4[] = {1, 1, 1, 1, 1}, k4 = 1, e4 = 0;
    int a5[] = {19, 3, -2, 18, 18, 77}, k5 = -4, e5 = 0;
    int a6[] = {9, 10, 11, 12, 13, 9, 10, 11}, k6 = 20, e6 = 1;
    int a7[] = {9, 31, 27, -11, -12}, k7 = 19, e7 = 1;

    test(a1, sizeof(a1)/sizeof(int), k1, e1);
    test(a2, sizeof(a2)/sizeof(int), k2, e2);
    test(a3, sizeof(a3)/sizeof(int), k3, e3);
    test(a4, sizeof(a4)/sizeof(int), k4, e4);
    test(a5, sizeof(a5)/sizeof(int), k5, e5);
    test(a6, sizeof(a6)/sizeof(int), k6, e6);
    test(a7, sizeof(a7)/sizeof(int), k7, e7);

    return 0;
}
