/* es2-matrice-triangolare-sup.c */
#include <stdio.h>
#include <stdlib.h>

/* FUNZIONE DA REALIZZARE
   ======================

   Una matrice quadrata m è una matrice triangolare superiore se e
   solo se tutti i valori al di sotto della diagonale principale
   valgono zero.  Ad esempio, una matrice quadrata di dimensioni 8x8 è
   una matrice triangolare superiore se e solo se gli elementi
   indicati con l'asterisco valgono zero (quelli indicati con ?
   possono avere valore arbitrario):

   ????????
   *???????
   **?????? 
   ***?????
   ****????
   *****???
   ******??
   *******?

   Completare la funzione matrice_triangolare_sup(m) riportata sotto, che
   dato come parametro una matrice quadrata di interi di dimensioni
   8x8 restituisce 1 se e solo se m è una matrice triangolare
   superiore, 0 altrimenti.

*/
int matrice_triangolare_sup( int m[8][8] )
{
    return -1;
}

void test( int m[8][8], int expect )
{
    int r = matrice_triangolare_sup(m);
    if (r == expect) {
        printf("Test OK\n");
    } else {
        printf("Test FALLITO: risultato atteso %d, risultato ottenuto %d\n", expect, r);
    }
}

int main( void )
{
    int m1[][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0}};

    int m2[][8] = {{1, 2, 3, 4, 5, 6, 7, 8},
                   {0, 2, 3, 4, 5, 6, 7, 8},
                   {0, 0, 3, 4, 5, 6, 7, 8},
                   {0, 0, 0, 4, 5, 6, 7, 8},
                   {0, 0, 0, 0, 5, 6, 7, 8},
                   {0, 0, 0, 0, 0, 6, 7, 8},
                   {0, 0, 0, 0, 0, 0, 7, 8},
                   {0, 0, 0, 0, 0, 0, 0, 8}};

    int m3[][8] = {{1, 2, 3, 4, 5, 6, 7, 8},
                   {0, 2, 3, 4, 5, 6, 7, 8},
                   {0, 0, 3, 4, 5, 6, 7, 8},
                   {0, 0, 0, 4, 5, 6, 7, 8},
                   {0, 0, 0, 0, 5, 6, 7, 8},
                   {0, 0, 0, 0, 0, 6, 7, 8},
                   {0, 0, 0, 0, 0, 0, 7, 8},
                   {0, 0, 0, 0, 0, 0, 0, 8}};

    int m4[][8] = {{1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8},
                   {1, 2, 3, 4, 5, 6, 7, 8}};

    int m5[][8] = {{0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0},
                   {0, 0, 1, 0, 0, 0, 0, 0},
                   {0, 0, 0, 0, 0, 0, 0, 0}};

    int m6[][8] = {{1, 0, 0, 0, 0, 0, 0, 0},
                   {0, 2, 0, 0, 0, 0, 0, 0},
                   {0, 0, 3, 0, 0, 0, 0, 0},
                   {0, 0, 0, 4, 0, 0, 0, 0},
                   {0, 0, 0, 0, 5, 0, 0, 0},
                   {0, 0, 0, 0, 0, 6, 0, 0},
                   {0, 0, 0, 0, 0, 0, 7, 0},
                   {0, 0, 0, 0, 0, 0, 0, 8}};

    int m7[][8] = {{1, 0, 0, 0, 0, 0, 0, 0},
                   {0, 2, 0, 0, 0, 0, 0, 0},
                   {0, 1, 3, 0, 0, 0, 0, 0},
                   {0, 0, 0, 4, 0, 0, 0, 0},
                   {0, 0, 1, 0, 5, 0, 0, 0},
                   {0, 0, 0, 0, 1, 6, 0, 0},
                   {0, 0, 0, 0, 0, 1, 7, 0},
                   {0, 0, 0, 0, 0, 0, 0, 8}};

    printf("=== Inizio test ===\n");
    test(m1, 1);
    test(m2, 1);
    test(m3, 1);
    test(m4, 0);
    test(m5, 0);
    test(m6, 1);
    test(m7, 0);
    printf("=== Fine test ===\n");    
    return 0;
}
