/* biquadrato.c */
#include <stdio.h>

/* Un numero intero n>0 e' un "numero biquadrato" se puo' essere
   espresso come somma dei quadrati di due numeri interi (non
   necessariamente distinti). Formalmente, n>0 e' un numero biquadrato
   se e solo se esistono due interi x>0, y>0 tali che n = x*x + y*y.

   Alcuni numeri biquadrati sono:
   5 = 1*1 + 2*2
   34 = 3*3 + 5*5
   585 = 12*12 + 21*21

   1. Scrivere una funzione int biquadrato(int n) che accetta come
      parametro un intero n>0, e restituisce 1 se n e' un numero
      biquadrato, 0 altrimenti.

   2. Usando la funzione di cui al punto precedente, calcolare quanti
      sono i numeri biquadrati compresi tra 1 e 1000, estremi inclusi,
      stampando a video il risultato.
*/
int biquadrato(int n)
{
    int x, y;
    /* consideriamo tutte le coppie di interi (x,y) tali che 1 <= x <=
       y. Questo migliore leggermente l'efficienza di questa funzione,
       dato che solo una delle coppie (x,y) (y,x) sono controllate. */
    for (x=1; x*x < n; x++) {
        for (y=x; x*x + y*y <= n; y++) {
            if (n == x*x + y*y) return 1;
        }        
    }
    return 0;
}

int main( void )
{
    int i, c=0;
    for (i=1; i<=1000; i++) {
        c += biquadrato(i);
    }
    printf("%d\n", c);
    return 0;
}
